Index: conftest.py
===================================================================
--- conftest.py	(revision f6fd413b32398bc181650cdaf712d5f2981dfc85)
+++ conftest.py	(revision f6fd413b32398bc181650cdaf712d5f2981dfc85)
@@ -0,0 +1,119 @@
+"""
+pytest hooks for sasmodels
+
+Hooks for running sasmodels tests via pytest.
+
+*pytest_collection_modifyitems* adds the test description to the end of
+the test name.  This is needed for the generated list of tests is sasmodels,
+where each test has a description giving the name of the model.  For example
+"model_tests::[3]" becomes "model_tests::[3]::bcc_paracrystal-dll".  Need to
+leave the "::[3]" in the name since that is the way you can indicate this
+test specifically from the pytest command line. [This is perhaps because
+the modifyitems hook is only called after test selection.]
+
+*pytest_ignore_collect* skips kernelcl.py if pyopencl cannot be imported.
+"""
+from __future__ import print_function
+
+import os.path
+import inspect
+
+import pytest
+from _pytest.unittest import TestCaseFunction
+
+def pytest_pycollect_makeitem(collector, name, obj):
+    """
+    Convert test generator into list of function tests so that pytest doesn't
+    complain about deprecated yield tests.
+
+    Note that unlike nose, the tests are generated and saved instead of run
+    immediately.  This means that any dynamic context, such as a for-loop
+    variable, must be captured by wrapping the yield result in a function call.
+
+    For example::
+
+        for value in 1, 2, 3:
+            for test in test_cases:
+                yield test, value
+
+    will need to be changed to::
+
+        def build_test(test, value):
+            return test, value
+        for value in 1, 2, 3:
+            for test in test_cases:
+                yield build_test(test, value)
+
+    This allows the context (test and value) to be captured by lexical closure
+    in build_test. See https://stackoverflow.com/a/233835/6195051.
+    """
+    if collector.istestfunction(obj, name) and is_generator(obj):
+        tests = []
+        for number, yielded in enumerate(obj()):
+            index, call, args = split_yielded_test(yielded, number)
+            test = pytest.Function(name+index, collector, args=args, callobj=call)
+            tests.append(test)
+        return tests
+
+def is_generator(func):
+    """
+    Returns True if function has yield.
+    """
+    # Cribbed from _pytest.compat is_generator and iscoroutinefunction; these
+    # may not be available as part of pytest 4.
+    coroutine = (getattr(func, '_is_coroutine', False) or
+                 getattr(inspect, 'iscoroutinefunction', lambda f: False)(func))
+    generator = inspect.isgeneratorfunction(func)
+    return generator and not coroutine
+
+def split_yielded_test(obj, number):
+    if not isinstance(obj, (tuple, list)):
+        obj = (obj,)
+    if not callable(obj[0]):
+        index = "['%s']"%obj[0]
+        obj = obj[1:]
+    else:
+        index = "[%d]"%number
+    call, args = obj[0], obj[1:]
+    return index, call, args
+
+USE_DOCSTRING_AS_DESCRIPTION = True
+def pytest_collection_modifyitems(session, config, items):
+    """
+    Add description to the test node id if item is a function and function
+    has a description attribute or __doc__ attribute.
+    """
+    for item in items:
+        if isinstance(item, pytest.Function):
+            if isinstance(item, TestCaseFunction):
+                # TestCase uses item.name to find the method so skip
+                continue
+            function = item.obj
+
+            # If the test case provides a "description" attribute then use it
+            # as an extended description.  If there is no description attribute,
+            # then perhaps use the test docstring.
+            if USE_DOCSTRING_AS_DESCRIPTION:
+                description = getattr(function, 'description', function.__doc__)
+            else:
+                description = getattr(function, 'description', "")
+
+            # If description is not supplied but yield args are, then use the
+            # yield args for the description
+            if not description and getattr(item, '_args', ()):
+                description = (str(item._args) if len(item._args) > 1
+                               else str(item._args[0]))
+
+            # Set the description as part of the node identifier.
+            if description:
+                # Strip spaces from start and end and strip dots from end
+                # pytest converts '.' to '::' on output for some reason.
+                description = description.strip().rstrip('.')
+                # Join multi-line descriptions into a single line
+                if '\n' in description:
+                    description = " ".join(line.strip()
+                                           for line in description.split('\n'))
+
+                # Note: leave the current name mostly as-is since the prefix
+                # is needed to specify the nth test from a list of tests.
+                item.name += "::" + description
Index: doc/genapi.py
===================================================================
--- doc/genapi.py	(revision 706f46620c115bdbc319d902ba7678c9d247d6d0)
+++ doc/genapi.py	(revision 0d5a655d6ddebe6096fad050347df4796b956767)
@@ -69,4 +69,6 @@
     ('exception', 'Annotate exceptions'),
     ('generate', 'Model parser'),
+    ('jitter', 'Orientation explorer'),
+    ('guyou', 'Guyou map projection'),
     ('kernel', 'Evaluator type definitions'),
     ('kernelcl', 'OpenCL model evaluator'),
Index: example/SiO2_100pc_H2O_0pc_D2O.ses
===================================================================
--- example/SiO2_100pc_H2O_0pc_D2O.ses	(revision 31c64d9fb704dafacea12163abebeea818d3f11a)
+++ example/SiO2_100pc_H2O_0pc_D2O.ses	(revision b314f89020feac2b96e4731dd784a9df4981371c)
@@ -1,36 +1,45 @@
-name	SiO2 stober						
-sample	SiO2 100pcH2O						
-collimation	unknown						
-ID	CPD						
-Date	di 27 jan 2015 18:17:50						
-Method	Offspec						
-Thickness [mm]	1						
-z-acceptance [nm^-1]	0.3						
-y-acceptance [nm^-1]	0.3						
+FileFormatVersion       1.0
+DataFileTitle           SiO2 stober
+Sample                  SiO2 100pcH2O
+collimation             unknown
+ID                      CPD
+Date                    di 27 jan 2015 18:17:50
+Method                  Offspec
+Thickness               1
+Thickness_unit          mm
+Theta_zmax              0.0100
+Theta_zmax_unit         radians
+Theta_ymax              0.0100
+Theta_ymax_unit         radians
+Orientation             Z
+SpinEchoLength_unit     A
+Depolarisation_unit     A-2 cm-1
+Wavelength_unit         A
 
-spin echo length [nm]	error spin-echo length	wavelength [nm]	error wavelength	Sample P	Sample P -error		
-244.098	5	0.220907401	0.006627222	0.96321	0.0113507	0.029882023	29.882023
-340.136	5	0.260768096	0.007823043	0.973305	0.0034846	0.085257531	85.257531
-452.181	5	0.300665994	0.00901998	0.951588	0.00287498	0.140798634	140.798634
-580.232	5	0.340587727	0.010217632	0.911935	0.00310965	0.196560502	196.560502
-724.29	5	0.380526057	0.011415782	0.856129	0.00356166	0.252528125	252.528125
-884.354	5	0.420476016	0.01261428	0.78817	0.0036651	0.308729274	308.729274
-1060.42	5	0.460433709	0.013813011	0.719608	0.00386121	0.365037117	365.037117
-1252.5	5	0.50039968	0.01501199	0.653424	0.00418035	0.421684677	421.684677
-1460.58	5	0.540369504	0.016211085	0.603456	0.00472218	0.478564852	478.564852
-1684.67	5	0.580344105	0.017410323	0.558174	0.00537231	0.535715521	535.715521
-1924.77	5	0.620322561	0.018609677	0.532672	0.00617699	0.59324408	593.24408
-2180.87	5	0.660302658	0.01980908	0.505018	0.00707792	0.650985498	650.985498
-2452.98	5	0.700285542	0.021008566	0.475536	0.00829962	0.709203958	709.203958
-2741.1	5	0.740270761	0.022208123	0.440819	0.00957178	0.767809943	767.809943
-3045.22	5	0.780256676	0.0234077	0.397642	0.0111225	0.826762925	826.762925
-3365.35	5	0.820244402	0.024607332	0.363717	0.0132055	0.886302296	886.302296
-3701.48	5	0.860232527	0.025806976	0.302206	0.0158338	0.946236366	946.236366
-4053.62	5	0.900222106	0.027006663	0.302188	0.0204351	1.006784115	1006.784115
-4421.77	5	0.940212955	0.028206389	0.263252	0.0264158	1.067891213	1067.891213
-4805.92	5	0.980203897	0.029406117	0.230149	0.0339972	1.129598722	1129.598722
-5206.08	5	1.020195903	0.030605877	0.268749	0.0480167	1.192022694	1192.022694
-5622.25	5	1.060188851	0.031805666	0.340439	0.0701945	1.255271282	1255.271282
-6054.42	5	1.10018173	0.033005452	0.238197	0.0986631	1.319307134	1319.307134
-6502.6	5	1.140175425	0.034205263	0.0985987	0.170273	1.384197821	1384.197821
-6966.79	5	1.180169852	0.035405096	0.0814573	0.256765	1.448518618	1448.518618
+BEGIN_DATA
+ SpinEchoLength  Depolarisation  Depolarisation_error   Wavelength  Wavelength_error  SpinEchoLength_error  Polarisation  Polarisation_error 
+ 2440.98   -7.6810986e-3          2.4147998e-3   2.20907401        0.06627222                    50       0.96321           0.0113507 
+ 3401.36   -3.9790857e-3          5.2649599e-4   2.60768096        0.07823043                    50      0.973305           0.0034846 
+ 4521.81   -5.4892798e-3          3.3420831e-4   3.00665994         0.0901998                    50      0.951588          0.00287498 
+ 5802.32   -7.9471175e-3          2.9396095e-4   3.40587727        0.10217632                    50      0.911935          0.00310965 
+ 7242.9    -0.010727495          2.8730584e-4   3.80526057        0.11415782                    50      0.856129          0.00356166 
+ 8843.54    -0.013463878          2.6301679e-4   4.20476016         0.1261428                    50       0.78817           0.0036651 
+ 10604.2    -0.015521222          2.5310062e-4   4.60433709        0.13813011                    50      0.719608          0.00386121 
+12525.    -0.016993983          2.5549565e-4    5.0039968         0.1501199                    50      0.653424          0.00418035 
+14605.8    -0.017297381          2.6798795e-4   5.40369504        0.16211085                    50      0.603456          0.00472218 
+16846.7    -0.017312523          2.8577242e-4   5.80344105        0.17410323                    50      0.558174          0.00537231 
+19247.7    -0.016368225          3.0135741e-4   6.20322561        0.18609677                    50      0.532672          0.00617699 
+21808.7    -0.015668849          3.2144946e-4   6.60302658         0.1980908                    50      0.505018          0.00707792 
+24529.8    -0.015157278          3.5589713e-4   7.00285542        0.21008566                    50      0.475536          0.00829962 
+27411.    -0.014947440          3.9623352e-4   7.40270761        0.22208123                    50      0.440819          0.00957178 
+30452.2    -0.015147872          4.5944674e-4   7.80256676          0.234077                    50      0.397642           0.0111225 
+33653.5    -0.015032370          5.3964070e-4   8.20244402        0.24607332                    50      0.363717           0.0132055 
+37014.8    -0.016170897          7.0802787e-4   8.60232527        0.25806976                    50      0.302206           0.0158338 
+40536.2    -0.014766858          8.3444978e-4   9.00222106        0.27006663                    50      0.302188           0.0204351 
+44217.7    -0.015097771          1.1351144e-3   9.40212955        0.28206389                    50      0.263252           0.0264158 
+48059.2    -0.015289642          1.5374507e-3   9.80203897        0.29406117                    50      0.230149           0.0339972 
+52060.8    -0.012624691          1.7166363e-3  10.20195903        0.30605877                    50      0.268749           0.0480167 
+56222.5   -9.5864674e-3          1.8344138e-3  10.60188851        0.31805666                    50      0.340439           0.0701945 
+60544.2    -0.011852755          3.4220757e-3   11.0018173        0.33005452                    50      0.238197           0.0986631 
+65026.    -0.017820748           0.013284073  11.40175425        0.34205263                    50     0.0985987            0.170273 
+69667.9    -0.018004557           0.022631679  11.80169852        0.35405096                    50     0.0814573            0.256765 
Index: example/core_shell.ses
===================================================================
--- example/core_shell.ses	(revision 5be92e8a5dcd07938111a0bdbb02d17228ee1482)
+++ example/core_shell.ses	(revision e0721e71313986771b2683caa92a663ca838b9e4)
@@ -1,68 +1,100 @@
-name	se009051.dat						
-sample	"SiO2 pH=6 & NiO pH=10, nanosized, in D2O, Sine ++ only."						
-collimation	"D1=D2=20x8 mm,Ds = 16x10 mm (WxH), GF1 =scanning, GF2 = 2.5 A. "						
-ID	CPD						
-Date	di 27 jan 2015 18:17:50						
-Method	sine one element scan						
-Thickness [mm]	2						
-z-acceptance [nm^-1]	0.3						
-y-acceptance [nm^-1]	0.3						
+FileFormatVersion       1.0
+DataFileTitle    	se009051.dat						
+Sample  		"SiO2 pH=6 & NiO pH=10, nanosized, in D2O, Sine ++ only."						
+collimation             "D1=D2=20x8 mm,Ds = 16x10 mm (WxH), GF1 =scanning, GF2 = 2.5 A. "						
+ID			CPD						
+Date			di 27 jan 2015 18:17:50
+Method			sine one element scan
+Thickness               10
+Thickness_unit          mm
+Theta_zmax              0.0168
+Theta_zmax_unit         radians
+Theta_ymax              0.0168
+Theta_ymax_unit         radians
+Orientation             Z
+SpinEchoLength_unit     A
+Depolarisation_unit     A-2 cm-1
+Wavelength_unit         A
 							
-spin echo length [um]	error spin-echo length	wavelength [nm]	error wavelength	Sample 5	Sample 5 -error		
-26	5	0.161245	0.01	0.996315	0.00528445	0.161245	26
-28.08	5	0.167571	0.01	0.995937	0.00522962	0.167571	28.08
-30.3264	5	0.174145	0.01	0.995039	0.00371164	0.174145	30.3264
-32.7525	5	0.180977	0.01	0.99448	0.00381089	0.180977	32.7525
-35.3727	5	0.188076	0.01	0.992143	0.00319011	0.188076	35.3727
-38.2025	5	0.195455	0.01	0.991403	0.0032496	0.195455	38.2025
-41.2587	5	0.203122	0.01	0.990106	0.002978	0.203122	41.2587
-44.5594	5	0.211091	0.01	0.98857	0.00297338	0.211091	44.5594
-48.1242	5	0.219372	0.01	0.986236	0.00286669	0.219372	48.1242
-51.9741	5	0.227978	0.01	0.982739	0.00283988	0.227978	51.9741
-56.132	5	0.236922	0.01	0.979995	0.00287147	0.236922	56.132
-60.6226	5	0.246217	0.01	0.976516	0.00290667	0.246217	60.6226
-65.4724	5	0.255876	0.01	0.971858	0.00300969	0.255876	65.4724
-70.7102	5	0.265914	0.01	0.967518	0.00310597	0.265914	70.7102
-76.367	5	0.276346	0.01	0.963198	0.00310409	0.276346	76.367
-82.4764	5	0.287187	0.01	0.957071	0.00306271	0.287187	82.4764
-89.0745	5	0.298454	0.01	0.952784	0.00299587	0.298454	89.0745
-96.2005	5	0.310162	0.01	0.947462	0.0029896	0.310162	96.2005
-103.897	5	0.322331	0.01	0.941226	0.00300217	0.322331	103.897
-112.208	5	0.334975	0.01	0.936151	0.00305677	0.334975	112.208
-121.185	5	0.348116	0.01	0.930884	0.00307969	0.348116	121.185
-130.88	5	0.361773	0.01	0.927992	0.00316999	0.361773	130.88
-141.35	5	0.375965	0.01	0.926511	0.00326096	0.375965	141.35
-152.658	5	0.390715	0.01	0.925098	0.00340349	0.390715	152.658
-164.871	5	0.406043	0.01	0.924369	0.0035662	0.406043	164.871
-178.06	5	0.421972	0.01	0.925632	0.00372489	0.421972	178.06
-192.305	5	0.438526	0.01	0.922762	0.00390394	0.438526	192.305
-207.69	5	0.45573	0.01	0.918753	0.00412162	0.45573	207.69
-224.305	5	0.473608	0.01	0.90663	0.0043316	0.473608	224.305
-242.249	5	0.492188	0.01	0.893251	0.00454417	0.492188	242.249
-261.629	5	0.511497	0.01	0.878299	0.00473364	0.511497	261.629
-282.559	5	0.531563	0.01	0.867266	0.00497459	0.531563	282.559
-305.164	5	0.552417	0.01	0.859537	0.00521977	0.552417	305.164
-329.577	5	0.574088	0.01	0.855935	0.0055573	0.574088	329.577
-355.943	5	0.59661	0.01	0.851389	0.00581848	0.59661	355.943
-384.419	5	0.620015	0.01	0.836311	0.00620483	0.620015	384.419
-415.172	5	0.644338	0.01	0.821362	0.00668373	0.644338	415.172
-448.386	5	0.669616	0.01	0.803833	0.0071725	0.669616	448.386
-484.257	5	0.695886	0.01	0.792211	0.00786449	0.695886	484.257
-522.998	5	0.723186	0.01	0.787407	0.00860688	0.723186	522.998
-564.838	5	0.751557	0.01	0.765977	0.00938856	0.751557	564.838
-610.025	5	0.781041	0.01	0.746618	0.0101567	0.781041	610.025
-658.827	5	0.811682	0.01	0.734672	0.0110357	0.811682	658.827
-711.533	5	0.843524	0.01	0.720351	0.0118912	0.843524	711.533
-768.455	5	0.876616	0.01	0.692587	0.0130927	0.876616	768.455
-829.932	5	0.911006	0.01	0.674767	0.0137763	0.911006	829.932
-896.326	5	0.946745	0.01	0.664497	0.0148902	0.946745	896.326
-968.032	5	0.983886	0.01	0.634464	0.0158459	0.983886	968.032
-1045.47	5	1.02248	0.01	0.604792	0.0166925	1.02248	1045.47
-1129.11	5	1.0626	0.01	0.591534	0.0179667	1.0626	1129.11
-1219.44	5	1.10428	0.01	0.582625	0.0198223	1.10428	1219.44
-1317	5	1.14761	0.01	0.549232	0.0217725	1.14761	1317
-1422.36	5	1.19263	0.01	0.53863	0.024516	1.19263	1422.36
-1536.15	5	1.23942	0.01	0.521353	0.0281108	1.23942	1536.15
-1659.04	5	1.28804	0.01	0.460045	0.0314452	1.28804	1659.04
-1791.76	5	1.33857	0.01	0.411185	0.0366899	1.33857	1791.76
-1930.34	5	1.38937	0.01	0.414685	0.0478689	1.38937	1930.34
+BEGIN_DATA
+SpinEchoLength  SpinEchoLength_error  Wavelength  Wavelength_Error  Polarisation  Polarisation_error  Depolarisation  Depolarisation_error 
+298.82023 50 2.095 0.1 0.997817556 0.00887342 -4.9779370e-5 2.0261512e-4 
+852.57531 50 2.095 0.1 1.0026184 0.009572307 5.9579929e-5 2.1752686e-4 
+1407.9863 50 2.095 0.1 0.996013172 0.012119508 -9.1017859e-5 2.7723742e-4 
+1965.6050 50 2.095 0.1 0.991752656 0.011651473 -1.8868750e-4 2.6767598e-4 
+2525.2813 50 2.095 0.1 0.995429571 0.012193294 -1.0437182e-4 2.7908883e-4 
+3087.2927 50 2.095 0.1 0.995119819 0.009621277 -1.1146275e-4 2.2028721e-4 
+3650.3712 50 2.095 0.1 0.997497767 0.012518842 -5.7082583e-5 2.8594610e-4 
+4216.8468 50 2.095 0.1 0.994733865 0.010585926 -1.2030120e-4 2.4246770e-4 
+4785.6485 50 2.095 0.1 0.992696275 0.010677724 -1.6701950e-4 2.4507231e-4 
+5357.1552 50 2.095 0.1 0.994534294 0.012909556 -1.2487278e-4 2.9574914e-4 
+5932.4408 50 2.095 0.1 0.986412268 0.014651894 -3.1170682e-4 3.3842875e-4 
+6509.8550 50 2.095 0.1 0.988788566 0.015736468 -2.5688520e-4 3.6260666e-4 
+7092.0396 50 2.095 0.1 0.989501168 0.013611615 -2.4047103e-4 3.1341898e-4 
+7678.0994 50 2.095 0.1 0.99203933 0.016501891 -1.8210252e-4 3.7899787e-4 
+8267.6293 50 2.095 0.1 0.994062723 0.010276207 -1.3567871e-4 2.3553259e-4 
+8863.0230 50 2.095 0.1 0.979647192 0.011089421 -4.6850452e-4 2.5791174e-4 
+9462.3637 50 2.095 0.1 0.97982075 0.013168527 -4.6446835e-4 3.0621222e-4 
+10067.841 50 2.095 0.1 0.977927712 0.014362819 -5.0853039e-4 3.3463000e-4 
+10678.912 50 2.095 0.1 0.978351462 0.013239476 -4.9865985e-4 3.0832436e-4 
+11295.987 50 2.095 0.1 0.981246471 0.013896898 -4.3133968e-4 3.2267975e-4 
+11920.227 50 2.095 0.1 0.978275164 0.013747481 -5.0043677e-4 3.2017989e-4 
+12552.713 50 2.095 0.1 0.976818842 0.013487944 -5.3437989e-4 3.1460359e-4 
+13193.071 50 2.095 0.1 0.981546068 0.011972943 -4.2438423e-4 2.7792152e-4 
+13841.978 50 2.095 0.1 0.96445854 0.013357572 -8.2452102e-4 3.1555561e-4 
+14500.513 50 2.095 0.1 0.972756158 0.014756189 -6.2933879e-4 3.4562263e-4 
+15169.786 50 2.095 0.1 0.971010184 0.014210504 -6.7027011e-4 3.3343996e-4 
+15850.446 50 2.095 0.1 0.975009829 0.013648839 -5.7661387e-4 3.1894710e-4 
+16543.562 50 2.095 0.1 0.969575209 0.014454336 -7.0396574e-4 3.3966327e-4 
+17249.754 50 2.095 0.1 0.959907267 0.012806944 -9.3229353e-4 3.0398222e-4 
+17969.627 50 2.095 0.1 0.96219203 0.011845496 -8.7812744e-4 2.8049391e-4 
+18706.130 50 2.095 0.1 0.960157966 0.011721155 -9.2634378e-4 2.7813758e-4 
+19459.212 50 2.095 0.1 0.95089937 0.009967287 -1.1471121e-3 2.3882201e-4 
+20230.984 50 2.095 0.1 0.955584642 0.01104368 -1.0351259e-3 2.6331561e-4 
+21021.899 50 2.095 0.1 0.950786938 0.011651582 -1.1498062e-3 2.7921171e-4 
+21835.345 50 2.095 0.1 0.951403607 0.008784149 -1.1350335e-3 2.1036178e-4 
+22671.730 50 2.095 0.1 0.94561823 0.009392383 -1.2740040e-3 2.2630383e-4 
+23533.930 50 2.095 0.1 0.945882787 0.009468264 -1.2676305e-3 2.2806833e-4 
+24423.504 50 2.095 0.1 0.939583158 0.009164239 -1.4198814e-3 2.2222511e-4 
+25343.343 50 2.095 0.1 0.93731257 0.008621568 -1.4750079e-3 2.0957224e-4 
+26294.734 50 2.095 0.1 0.936639557 0.010408821 -1.4913733e-3 2.5319842e-4 
+27282.004 50 2.095 0.1 0.932091884 0.007112674 -1.6022666e-3 1.7386258e-4 
+28307.499 50 2.095 0.1 0.933852763 0.009200431 -1.5592642e-3 2.2447176e-4 
+29373.630 50 2.095 0.1 0.930283437 0.01022719 -1.6465153e-3 2.5047996e-4 
+30485.110 50 2.095 0.1 0.930121334 0.007055747 -1.6504858e-3 1.7283645e-4 
+31645.899 50 2.095 0.1 0.925944326 0.0078917 -1.7530356e-3 1.9418588e-4 
+32858.438 50 2.095 0.1 0.92351759 0.005522582 -1.8128270e-3 1.3624763e-4 
+34128.058 50 2.095 0.1 0.918228311 0.006917328 -1.9436940e-3 1.7164045e-4 
+35460.168 50 2.095 0.1 0.908621563 0.006852313 -2.1833230e-3 1.7182490e-4 
+36858.762 50 2.095 0.1 0.919087792 0.006995961 -1.9223776e-3 1.7342924e-4 
+38331.748 50 2.095 0.1 0.910132214 0.006107336 -2.1454742e-3 1.5289007e-4 
+39882.345 50 2.095 0.1 0.904491462 0.007078101 -2.2871233e-3 1.7829708e-4 
+41519.404 50 2.095 0.1 0.90056919 0.005934428 -2.3861400e-3 1.5013907e-4 
+43249.023 50 2.095 0.1 0.903155701 0.006249069 -2.3207959e-3 1.5764661e-4 
+45079.637 50 2.095 0.1 0.894919827 0.006196232 -2.5295172e-3 1.5775222e-4 
+47019.670 50 2.095 0.1 0.896358908 0.007324999 -2.4929085e-3 1.8619052e-4 
+49077.851 50 2.095 0.1 0.88807923 0.004530465 -2.7043436e-3 1.1623128e-4 
+51264.711 50 2.095 0.1 0.886649039 0.008924412 -2.7410654e-3 2.2932944e-4 
+53590.598 50 2.095 0.1 0.882051947 0.006055081 -2.8595036e-3 1.5640756e-4 
+56067.403 50 2.095 0.1 0.882573371 0.005727419 -2.8460388e-3 1.4785638e-4 
+58709.036 50 2.095 0.1 0.876289825 0.006062306 -3.0088321e-3 1.5762389e-4 
+61527.362 50 2.095 0.1 0.877318199 0.005307783 -2.9821094e-3 1.3784403e-4 
+64538.932 50 2.095 0.1 0.873610284 0.006918104 -3.0786086e-3 1.8042690e-4 
+67758.354 50 2.095 0.1 0.865954455 0.005625863 -3.2791557e-3 1.4802192e-4 
+71205.306 50 2.095 0.1 0.868037308 0.008662141 -3.2244196e-3 2.2736248e-4 
+74897.359 50 2.095 0.1 0.86676404 0.005761209 -3.2578647e-3 1.5144143e-4 
+78855.560 50 2.095 0.1 0.85655072 0.005731411 -3.5279304e-3 1.5245456e-4 
+83102.902 50 2.095 0.1 0.857936274 0.006954572 -3.4911046e-3 1.8469168e-4 
+87663.154 50 2.095 0.1 0.85520525 0.006559622 -3.5637478e-3 1.7475934e-4 
+92562.717 50 2.095 0.1 0.849739829 0.008907377 -3.7098230e-3 2.3883381e-4 
+97830.316 50 2.095 0.1 0.841487161 0.006547659 -3.9321836e-3 1.7728439e-4 
+103497.14 50 2.095 0.1 0.84801051 0.007574866 -3.7562386e-3 2.0351933e-4 
+109596.79 50 2.095 0.1 0.843342861 0.006411993 -3.8819940e-3 1.7322909e-4 
+116165.97 50 2.095 0.1 0.837488454 0.008141353 -4.0407107e-3 2.2148775e-4 
+123244.47 50 2.095 0.1 0.839214922 0.009987535 -3.9937900e-3 2.7115465e-4 
+130874.72 50 2.095 0.1 0.834336972 0.011467406 -4.1266093e-3 3.1315233e-4 
+139102.96 50 2.095 0.1 0.828775634 0.012483365 -4.2789870e-3 3.4318369e-4 
+147980.51 50 2.095 0.1 0.823088812 0.016035848 -4.4358638e-3 4.4389186e-4 
+157560.98 50 2.095 0.1 0.824329178 0.014838138 -4.4015548e-3 4.1011975e-4 
+167904.68 50 2.095 0.1 0.82023172 0.015286187 -4.5150892e-3 4.2461424e-4 
+179076.29 50 2.095 0.1 0.827559752 0.012612741 -4.3124376e-3 3.4724985e-4 
Index: example/fit.py
===================================================================
--- example/fit.py	(revision f4b36fa94da2129ef86fb36f21c6458873815e0f)
+++ example/fit.py	(revision 1ee5ac6835494f0c31e1e5bdd12583676a07d71e)
@@ -179,5 +179,5 @@
 
 else:
-    print "No parameters for %s"%name
+    print("No parameters for %s"%name)
     sys.exit(1)
 
@@ -192,2 +192,6 @@
 else:
    problem = FitProblem(M)
+
+if __name__ == "__main__":
+   problem.plot()
+   import pylab; pylab.show()
Index: example/multiscatfit.py
===================================================================
--- example/multiscatfit.py	(revision 49d1f8b8b50df60b60d3cc8b9dfe3c9c22f24db1)
+++ example/multiscatfit.py	(revision 49d1f8b8b50df60b60d3cc8b9dfe3c9c22f24db1)
@@ -0,0 +1,90 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+"""
+Fit model using multiple scattering.
+
+As of this writing, multiscattering isn't integrated into sasmodels, and a
+number of hacks are required to get it running as a fit.
+
+The appropriate items need to be on the python path.  These include
+sasview (for reading the data), sasmodels and bumps.  The multiscat module
+(currently in the sasmodels/explore directory) is also needed, either beside
+this example fit file, or by putting sasmdoels/explore on the python path.
+
+On Unix/Mac running as developer I do::
+
+    # Show the model without fitting
+    PYTHONPATH=..:../explore:../../bumps:../../sasview/src python multiscatfit.py
+
+    # Run the fit
+    PYTHONPATH=..:../explore:../../bumps:../../sasview/src ../../bumps/run.py \
+    multiscatfit.py --store=/tmp/t1
+
+You may be able to run multiscatfit.py against the distributed sasview
+application (if it is new enough, and if you have multiscat.py in the
+same directory).  You probably need a command such as::
+
+    sasview.exe bumps.cli multiscatfit.py --store=t1
+"""
+
+import sys
+from bumps.names import *
+from sasmodels.core import load_model
+from sasmodels.bumps_model import Model, Experiment
+from sasmodels.data import load_data, set_beam_stop, set_top
+
+from sasmodels.multiscat import MultipleScattering
+
+## Load the data
+#data = load_data('DEC07267.DAT')
+#set_beam_stop(data, 0.003, outer=0.025)
+data = load_data('latex_smeared.xml', index=0)
+
+## Define the model
+kernel = load_model("ellipsoid")
+
+model = Model(
+    kernel,
+    scale=0.005, background=0.05,
+    radius_polar=2200, radius_equatorial=2200,
+    sld=.291, sld_solvent=7.105,
+    #theta=90, theta_pd=0, theta_pd_n=0, theta_pd_nsigma=3,
+    #phi=90, phi_pd=0, phi_pd_n=20, phi_pd_nsigma=3,
+    radius_polar_pd=0.222296, radius_polar_pd_n=1, radius_polar_pd_nsigma=0,
+    radius_equatorial_pd=.000128, radius_equatorial_pd_n=1, radius_equatorial_pd_nsigma=0,
+    )
+
+# SET THE FITTING PARAMETERS
+model.radius_polar.range(15, 3000)
+model.radius_equatorial.range(15, 3000)
+#model.theta.range(0, 90)
+#model.theta_pd.range(0,10)
+#model.phi_pd.range(0,20)
+#model.phi.range(0, 180)
+model.background.range(0,1000)
+model.scale.range(0, 0.1)
+
+# Mulitple scattering probability parameter
+# HACK: the probability is stuffed in as an extra parameter to the experiment.
+probability = Parameter(name="probability", value=0.0)
+probability.range(0.0, 0.9)
+
+M = Experiment(data=data, model=model, extra_pars={'probability': probability})
+
+# Stack mulitple scattering on top of the existing resolution function.
+# Because resolution functions in sasview don't have fitting parameters,
+# we instead allow the multiple scattering calculator to take a function
+# instead of a probability.  This function returns the current value of
+# the parameter. ** THIS IS TEMPORARY ** when multiple scattering is
+# properly integrated into sasmodels and sasview, its fittable parameter
+# will be treated like the model parameters.
+M.resolution = MultipleScattering(resolution=M.resolution,
+                                  probability=lambda: probability.value,
+                                  )
+M._kernel_inputs = M.resolution.q_calc
+problem = FitProblem(M)
+
+if __name__ == "__main__":
+    #M.theory()
+    M.plot()
+    import pylab; pylab.show()
